package com.bjtdba.userCenter.dao;

import com.bjtdba.entity.userCenter.UserClockes;
import com.bjtdba.userCenter.vo.ClockesVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 用户步数表(UserClockes)表数据库访问层
 *
 * @author 何海强
 * @since 2022-11-11 10:08:55
 */
@Mapper
public interface UserClockesDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    UserClockes queryById(Integer id);

    UserClockes queryByUid(Integer uid);

    Integer queryClockeUid(Integer uid);

    /**
     * 查询指定行数据
     *
     * @param userClockes 查询条件
//     * @param pageable         分页对象
     * @return 对象列表
     */
    List<UserClockes> queryAllByLimit(UserClockes userClockes);

    /***
     * 统计总步数
     * @param uid
     * @return
     */
    Long sumNum(Integer uid);

    /**
     * 统计总行数
     *
     * @param userClockes 查询条件
     * @return 总行数
     */
    long count(UserClockes userClockes);

    /**
     * 新增数据
     *
     * @param userClockes 实例对象
     * @return 影响行数
     */
    int insert(UserClockes userClockes);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<UserClockes> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<UserClockes> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<UserClockes> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<UserClockes> entities);

    /**
     * 修改数据
     *
     * @param userClockes 实例对象
     * @return 影响行数
     */
    int update(UserClockes userClockes);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    List<ClockesVo> countList(String type);

}

